EDIT - bug #9356

Comparison method violates its general contract for SourceComparator and
TypeDesignationComparator

12/10/2020 02:02 PM - Katja Luther

Status: Closed Start date:

Priority: Highest Due date:

Assignee: Katja Luther % Done: 70%
Category: taxeditor Estimated time: 0:00 hour
Target version: Release 5.19

Severity: normal Found in Version:

Description

There are two comparators violating the contract: SourceComparator in taxeditor and typeDesignationComparator in cdmlib

last remote method : http://api.cybertaxonomy.org:80/casearia/remoting/common.service
last remote request client time : 2020-12-10T09:49:21.702

last remote request response header time : Thu, 10 Dec 2020 09:49:21 GMT

client error time : 2020-12-10T09:49:21.745

login : a.demestier
editor version : 5.18.0
server : api.cybertaxonomy.org (cybertaxonomy.org) / casearia

schema version : 5.18.6.0.20201124
os : Windows 7 6.1 amdé64
java : 1.8.0_121
java.lang.IllegalArgumentException: Comparison method violates its general contract!

at java.util.TimSort.mergeLo (TimSort.java:777)

at java.util.TimSort.mergeAt (TimSort.java:514)

at java.util.TimSort.mergeForceCollapse (TimSort.java:457)

at java.util.TimSort.sort (TimSort. java:254)

at java.util.Arrays.sort (Arrays.java:1512)

at java.util.ArrayList.sort (ArrayList.java:1454)

at java.util.Collections.sort (Collections.java:175)

at eu.etaxonomy.taxeditor.ui.section.AbstractEntityCollectionSection.renderContent
(AbstractEntityCollectionSection. java:230)

at eu.etaxonomy.taxeditor.ui.section.AbstractEntityCollectionSection.expansionStat
eChanged (AbstractEntityCollectionSection. java:316)

at org.eclipse.ui.forms.widgets.ExpandableComposite.fireExpanding (ExpandableCompos
ite.java:1089)

at org.eclipse.ui.forms.widgets.ExpandableComposite.toggleState (ExpandableComposit
e.java:1075)

at org.eclipse.ui.forms.widgets.ExpandableComposite.access$5 (ExpandableComposite. j
ava:1071)

at org.eclipse.ui.forms.widgets.ExpandableComposite$2.linkActivated (ExpandableComp
osite.java:569)

at org.eclipse.ui.forms.widgets.AbstractHyperlink.handleActivate (AbstractHyperlink

.java:228)

at org.eclipse.ui.forms.widgets.AbstractHyperlink.handleMouseUp (AbstractHyperlink.
java:322)

at org.eclipse.ui.forms.widgets.AbstractHyperlink.access$2 (AbstractHyperlink. java:
306)

at org.eclipse.ui.forms.widgets.AbstractHyperlink$4.handleEvent (AbstractHyperlink.
java:129)

at org.eclipse.swt.widgets.EventTable.sendEvent (EventTable. java:84)

at org.eclipse.swt.widgets.Display.sendEvent (Display.java:4418)

at org.eclipse.swt.widgets.Widget.sendEvent (Widget. java:1079)

at org.eclipse.swt.widgets.Display.runDeferredEvents (Display.java:4236)

at org.eclipse.swt.widgets.Display.readAndDispatch (Display.java:3824)

at org.eclipse.e4.ui.internal.workbench.swt.PartRenderingEngine$4.run (PartRenderin
gEngine.java:1121)

at org.eclipse.core.databinding.observable.Realm.runWithDefault (Realm. java:336)

at org.eclipse.ed.ui.internal.workbench.swt.PartRenderingEngine.run (PartRenderingk
ed.ui.internal.workbench.E4Workbench.createAndRunUI (E4Workbench. jav

ui.internal.Workbench$5.run (Workbench. java:693)
core.databinding.observable.Realm.runWithDefault (Realm. java:336)
ui.internal.Workbench.createAndRunWorkbench (Workbench. java:610)
ui.PlatformUI.createAndRunWorkbench (PlatformUI. java:148)

eu.etaxonomy.taxeditor.Application.start (Application. java:20)

org.eclipse.equinox.internal.app.EclipseAppHandle.run (EclipseAppHandle.java:196

org.eclipse.core.runtime.internal.adaptor.EclipseAppLauncher.runApplication (Ecl
ipseAppLauncher. java:134)

org.

org.
.eclipse.

org

sun.
sun.
sun.

eclipse.
eclipse.
reflect.

reflect.
reflect.

core.runtime.internal.adaptor.EclipseAppLauncher.start (EclipseAppLa

core.runtime.adaptor.EclipseStarter.run(EclipseStarter.java:388)
core.runtime.adaptor.EclipseStarter.run(EclipseStarter.java:243)
NativeMethodAccessorImpl.invokeO (Native Method)
NativeMethodAccessorImpl.invoke (NativeMethodAccessorImpl. java:62)
DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. ja

java.lang.reflect.Method.invoke (Method. java:498)

org.eclipse.equinox.launcher.Main.invokeFramework (Main. java:673)

org.eclipse.equinox.launcher.Main.basicRun (Main. java:610)

org.eclipse.equinox.launcher.Main.run (Main. java:1519)

Associated revisions

Revision 40d48f6f - 12/11/2020 09:48 AM - Katja Luther

ref #9356: hotfix solution

Revision 56¢f6417 - 12/11/2020 10:02 AM - Katja Luther

ref #9356: hotfix solution

Revision 8e507020 - 01/15/2021 10:00 AM - Katja Luther

ref #9356: adapt TypeDesignationComparator

Revision c018f269 - 01/15/2021 10:11 AM - Katja Luther

ref #9356: remove hotfix workaround

Revision 9¢187406 - 01/21/2021 07:23 PM - Andreas Miiller

ref #9356 adapt TypeDesignationComparator to fix case when both type status are null ; and cleanup null compare part above

Revision 56613858 - 01/21/2021 08:35 PM - Andreas Miiller

ref #9356 clean up SourceComparator

History

#1 - 12/10/2020 03:29 PM - Andreas Miiller

- Status changed from New to In Progress

- Target version changed from Unassigned CDM tickets to Release 5.19

#2 - 01/15/2021 10:12 AM - Katja Luther

- Status changed from In Progress to Resolved

- Assignee changed from Katja Luther to Andreas Miiller

- % Done changed from 0 to 50

adapted the comparator in cdmlib and removed hotfix workaround, please review.

#3 - 01/21/2021 07:34 PM - Andreas Miuller

- Status changed from Resolved to Feedback

- Assignee changed from Andreas Muiller to Katja Luther
For TypeDesignationComparator the line

return ol.getUuid() .compareTo (02.getUuid());

will never be reached as if any of the type status are null 1 or -1 is returned before.
| adapted the code to make the different cases clearer.

Can you please review the code?

It would be good to have tests on such tests so these errors can be found easily.

#4 - 01/21/2021 08:16 PM - Andreas Miiller
- % Done changed from 50 to 70

The SourceComparator looks fine. | only cleaned it up a bit.

#5 - 01/22/2021 09:14 AM - Katja Luther
- Status changed from Feedback to Closed
Andreas Muller wrote:

For TypeDesignationComparator the line

return ol.getUuid() .compareTo (02.getUuid());

will never be reached as if any of the type status are null 1 or -1 is returned before.

| adapted the code to make the different cases clearer.
Can you please review the code?

It would be good to have tests on such tests so these errors can be found easily.

looks fine
